"use strict";
exports.__esModule = true;
var function_to_arrow_1 = require("../function-to-arrow");
var range = require("../../range");
var test_utils_1 = require("./test-utils");
var jscodeshift = require("jscodeshift");
var buildEditResponse = test_utils_1.createBuildFunction(function_to_arrow_1["default"]);
describe('javascript', function () {
    it('no arguments', function () {
        var source = 'const a = function () { return 1; }';
        var r = buildEditResponse(source, range.create(1, 11, 1, 11));
        expect(r).toEqual({
            newText: '() => { return 1; }',
            range: { end: { column: 35, line: 1 }, start: { column: 10, line: 1 } },
            title: 'Convert to arrow function'
        });
    });
    it('no action when "this" is used inside', function () {
        var source = 'const a = function () { this.call() }';
        var api = jscodeshift.withParser('babylon');
        var params = {
            j: api,
            ast: api(source),
            selection: range.create(1, 11, 1, 11),
            logger: console
        };
        var action = function_to_arrow_1["default"].suggestCodeAction(params);
        expect(action).toEqual(null);
    });
});
