"use strict";
exports.__esModule = true;
var Range = require("../range");
var Ast = require("../ast");
var Patch = require("../patch");
var fixer = {
    suggestCodeAction: function (params) {
        var j = params.j, ast = params.ast;
        var node = Ast.findFirstNode(ast, j.CallExpression, function (n) {
            return (n.loc !== null &&
                Range.isInside(params.selection, n.loc) &&
                j.MemberExpression.check(n.callee) &&
                j.Identifier.check(n.callee.object) &&
                n.callee.object.name === 'it' &&
                j.Identifier.check(n.callee.property) &&
                n.callee.property.name === 'skip');
        });
        if (!node || !node.loc) {
            return null;
        }
        return {
            title: "Enable test",
            data: node.loc.start
        };
    },
    createEdit: function (params) {
        var data = params.data, ast = params.ast, j = params.j;
        var node = Ast.findFirstNode(ast, j.CallExpression, function (n) { return Ast.isOnPosition(n, data); });
        if (!node) {
            return null;
        }
        var id = node.callee;
        var newNode = j.identifier('it');
        return Patch.replaceNode(j, id, newNode);
    }
};
exports["default"] = fixer;
